package com.fp.persistence.parmas.param;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSITIOALMACENAMIENTO*/
@Entity(name="TarmSitioAlmacenamiento")
@Table(name="TARMSITIOALMACENAMIENTO")
public class TarmSitioAlmacenamiento extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSitioAlmacenamiento
*/
@Id
@Column(name="CSITIOALMACENAMIENTO" ,nullable=false, updatable=false)
@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SequenceKey", parameters = {
        @Parameter(name = "name", value = "CSITIOALMACENAMIENTO"),//campo secuencial de la tabla
        @Parameter(name = "type", value = "java.lang.String"),// tipo de dato
        @Parameter(name = "fill", value = "0"),
        @Parameter(name = "length", value = "6")})
    @GeneratedValue(generator = "seq_id")
private String pk;
@Column(name="TIPOCOMERCIO", nullable=true)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String tipocomercio;

@Column(name="TIPOCOMERCIOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String tipocomerciocodigo;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="COUNTRYCODE", nullable=true)

/**
* Codigo de pais
*/
private String countrycode;

@Column(name="PROVINCECODE", nullable=true)

/**
* Codigo de provincia
*/
private String provincecode;

@Column(name="CANTONCODE", nullable=true)

/**
* Codigo de canton
*/
private String cantoncode;

@Column(name="PARROQUIACODE", nullable=true)

/**
* Codigo de parroquia
*/
private String parroquiacode;

@Column(name="CITYCODE", nullable=true)

/**
* Codigo de cuidad
*/
private String citycode;

@Column(name="BODEGA", nullable=true)

/**
* null
*/
private String bodega;

@Column(name="DIRECCION", nullable=true)

/**
* null
*/
private String direccion;

@Column(name="LATITUD", nullable=true)

/**
* null
*/
private BigDecimal latitud;

@Column(name="LONGITUD", nullable=true)

/**
* null
*/
private BigDecimal longitud;

@Column(name="RESPONSABLE", nullable=true)

/**
* null
*/
private String responsable;

@Column(name="IDENTIFICACION", nullable=true)

/**
* null
*/
private String identificacion;

@Column(name="TELEFONO", nullable=true)

/**
* Campo qu registra el Telèfono de la bodega
*/
private String telefono;

@Column(name="REFERENCIA", nullable=true)

/**
* Campo que registra la referencia deonde esta localizada la bodega
*/
private String referencia;

@Column(name="ESTADO", nullable=true)

/**
* Campo que contiene el estado del registro
*/
private String estado;

/**Contructor por defecto*/
public TarmSitioAlmacenamiento(){
}
/**Contructor de TarmSitioAlmacenamiento
@param pPk Clave Primaria del entity
*/
public TarmSitioAlmacenamiento(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSitioAlmacenamiento
*/
public static TarmSitioAlmacenamiento find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmSitioAlmacenamiento obj = pEntityManager.find(TarmSitioAlmacenamiento.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSitioAlmacenamiento
@return El objeto que referencia a la Clave primaria de TarmSitioAlmacenamiento
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSitioAlmacenamiento
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSitioAlmacenamiento
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de tipocomercio
@return valor de tipocomercio*/
public String getTipocomercio(){
  return tipocomercio;
}
/**Fija el valor de tipocomercio
@param pTipocomercio nuevo Valor de tipocomercio*/
public void setTipocomercio(String pTipocomercio){
  tipocomercio=pTipocomercio;
}

/**Obtiene el valor de tipocomerciocodigo
@return valor de tipocomerciocodigo*/
public String getTipocomerciocodigo(){
  return tipocomerciocodigo;
}
/**Fija el valor de tipocomerciocodigo
@param pTipocomerciocodigo nuevo Valor de tipocomerciocodigo*/
public void setTipocomerciocodigo(String pTipocomerciocodigo){
  tipocomerciocodigo=pTipocomerciocodigo;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de countrycode
@return valor de countrycode*/
public String getCountrycode(){
  return countrycode;
}
/**Fija el valor de countrycode
@param pCountrycode nuevo Valor de countrycode*/
public void setCountrycode(String pCountrycode){
  countrycode=pCountrycode;
}

/**Obtiene el valor de provincecode
@return valor de provincecode*/
public String getProvincecode(){
  return provincecode;
}
/**Fija el valor de provincecode
@param pProvincecode nuevo Valor de provincecode*/
public void setProvincecode(String pProvincecode){
  provincecode=pProvincecode;
}

/**Obtiene el valor de cantoncode
@return valor de cantoncode*/
public String getCantoncode(){
  return cantoncode;
}
/**Fija el valor de cantoncode
@param pCantoncode nuevo Valor de cantoncode*/
public void setCantoncode(String pCantoncode){
  cantoncode=pCantoncode;
}

/**Obtiene el valor de parroquiacode
@return valor de parroquiacode*/
public String getParroquiacode(){
  return parroquiacode;
}
/**Fija el valor de parroquiacode
@param pParroquiacode nuevo Valor de parroquiacode*/
public void setParroquiacode(String pParroquiacode){
  parroquiacode=pParroquiacode;
}

/**Obtiene el valor de citycode
@return valor de citycode*/
public String getCitycode(){
  return citycode;
}
/**Fija el valor de citycode
@param pCitycode nuevo Valor de citycode*/
public void setCitycode(String pCitycode){
  citycode=pCitycode;
}

/**Obtiene el valor de bodega
@return valor de bodega*/
public String getBodega(){
  return bodega;
}
/**Fija el valor de bodega
@param pBodega nuevo Valor de bodega*/
public void setBodega(String pBodega){
  bodega=pBodega;
}

/**Obtiene el valor de direccion
@return valor de direccion*/
public String getDireccion(){
  return direccion;
}
/**Fija el valor de direccion
@param pDireccion nuevo Valor de direccion*/
public void setDireccion(String pDireccion){
  direccion=pDireccion;
}

/**Obtiene el valor de latitud
@return valor de latitud*/
public BigDecimal getLatitud(){
  return latitud;
}
/**Fija el valor de latitud
@param pLatitud nuevo Valor de latitud*/
public void setLatitud(BigDecimal pLatitud){
  latitud=pLatitud;
}

/**Obtiene el valor de longitud
@return valor de longitud*/
public BigDecimal getLongitud(){
  return longitud;
}
/**Fija el valor de longitud
@param pLongitud nuevo Valor de longitud*/
public void setLongitud(BigDecimal pLongitud){
  longitud=pLongitud;
}

/**Obtiene el valor de responsable
@return valor de responsable*/
public String getResponsable(){
  return responsable;
}
/**Fija el valor de responsable
@param pResponsable nuevo Valor de responsable*/
public void setResponsable(String pResponsable){
  responsable=pResponsable;
}

/**Obtiene el valor de identificacion
@return valor de identificacion*/
public String getIdentificacion(){
  return identificacion;
}
/**Fija el valor de identificacion
@param pIdentificacion nuevo Valor de identificacion*/
public void setIdentificacion(String pIdentificacion){
	identificacion=pIdentificacion;
}

/**Obtiene el valor de telefono
@return valor de telefono*/
public String getTelefono(){
  return telefono;
}
/**Fija el valor de telefono
@param pTelefono nuevo Valor de telefono*/
public void setTelefono(String pTelefono){
  telefono=pTelefono;
}

/**Obtiene el valor de referencia
@return valor de referencia*/
public String getReferencia(){
  return referencia;
}
/**Fija el valor de referencia
@param pReferencia nuevo Valor de referencia*/
public void setReferencia(String pReferencia){
  referencia=pReferencia;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSitioAlmacenamiento))return false;
    TarmSitioAlmacenamiento that = (TarmSitioAlmacenamiento) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSitioAlmacenamiento
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSitioAlmacenamiento
*/
public Object createInstance(){
 TarmSitioAlmacenamiento instance=new TarmSitioAlmacenamiento();	
 return instance;
}
/**Clona la entidad TarmSitioAlmacenamiento
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSitioAlmacenamiento p=(TarmSitioAlmacenamiento)this.clone();
  return p;
}
public String getEstado() {
	return estado;
}
public void setEstado(String estado) {
	this.estado = estado;
}
}
